;----------------------------------------------------------------------------
;				NES Startup
;					Copyright (C) 2007, Tekepen
;					Arranged By 2015, @MIRROR_
;----------------------------------------------------------------------------
.setcpu		"6502"
.autoimport	on
.importzp	sp
.import		__STACK_START__, __STACK_SIZE__

.global	_NesMain

; iNESwb_
.segment "HEADER"
	.byte	$4E, $45, $53, $1A	; "NES" Header
	.byte	$02			; PRG-BANKS 16K x 2
	.byte	$01			; CHR-BANKS  8k x 1
	.byte	$00			; 0:Horizontal/1:Vertical/3:Vertical & WRAM Mirror
	.byte	$00			; 
	.byte	$00, $00, $00, $00	; 
	.byte	$00, $00, $00, $00	; 

.segment "STARTUP"

; Zbg荞
.proc	RESET
	sei
	ldx	#$ff
	txs
	
	; cc65p[^X^bNݒ
	lda     #<(__STACK_START__ + __STACK_SIZE__)
	sta	sp
	lda     #>(__STACK_START__ + __STACK_SIZE__)
	sta	sp + 1
	
	; C֐Ăяo
	jsr	_NesMain
.endproc

; NMI荞
.proc	NMI
	; WX^ޔ
	pha
	txa
	pha
	tya
	pha

	; NMI荞ݏĂяo
	jsr	_NMIProc

	; WX^A
	pla
	tay
	pla
	tax
	pla

	; 荞ݏI
	rti
.endproc

; xN^e[u
.segment "VECTORS"
	.word	NMI
	.word	RESET
	.word	$0000
